namespace CMSMicroservice.Application.UserWalletHistoryCQ.Commands.CreateNewUserWalletHistory;
public class CreateNewUserWalletHistoryCommandValidator : AbstractValidator<CreateNewUserWalletHistoryCommand>
{
    public CreateNewUserWalletHistoryCommandValidator()
    {
        RuleFor(model => model.WalletId)
            .NotNull();
        RuleFor(model => model.CurrentBalance)
            .NotNull();
        RuleFor(model => model.ChangeValue)
            .NotNull();
        RuleFor(model => model.CurrentNetworkBalance)
            .NotNull();
        RuleFor(model => model.ChangeNerworkValue)
            .NotNull();
        RuleFor(model => model.IsIncrease)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserWalletHistoryCommand>.CreateWithOptions((CreateNewUserWalletHistoryCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
